import { AfterViewInit, ChangeDetectorRef, ElementRef, EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { FormGroup, NgForm, ValidatorFn } from '@angular/forms';
import { MatFormFieldAppearance } from '@angular/material/form-field';
import { SdLabelDefDirective, SdSuffixDefDirective, SdViewDefDirective } from '@sd-angular/core/forms/directives';
import { ISdFormConfiguration, SdCustomValidator, SdFormControl } from '@sd-angular/core/forms/models';
import { SdSize } from '@sd-angular/core/utilities';
import * as i0 from "@angular/core";
export declare class SdTextarea implements OnInit, AfterViewInit, OnDestroy {
    #private;
    private ref;
    private formConfig;
    id: string;
    autoId?: string;
    set _autoId(val: string | undefined | null);
    set name(val: string | undefined);
    size?: SdSize;
    appearance: MatFormFieldAppearance;
    set form(val: NgForm | FormGroup | undefined | null);
    label?: string;
    set _label(val: string | undefined);
    helperText?: string;
    set _helperText(val: string | undefined);
    placeholder: string;
    rows: number;
    set model(value: any);
    modelChange: EventEmitter<any>;
    sdChange: EventEmitter<any>;
    hideInlineError: boolean;
    set _hideInlineError(val: boolean | '' | undefined | null);
    required: boolean;
    set _required(val: boolean | '' | undefined | null);
    maxlength: number | null;
    set _maxlength(val: number | undefined | null);
    set pattern(val: string);
    set validator(validator: SdCustomValidator | undefined);
    inlineError?: string;
    set _inlineError(val: string);
    set disabled(val: boolean | '' | undefined | null);
    viewed: boolean;
    set _viewed(val: boolean | '' | undefined | null);
    set _autoHeight(val: boolean | '');
    textarea: ElementRef;
    sdViewDef?: SdViewDefDirective;
    sdLabelDef?: SdLabelDefDirective;
    sdSuffixDef?: SdSuffixDefDirective;
    isFocused: boolean;
    formControl: SdFormControl;
    constructor(ref: ChangeDetectorRef, formConfig: ISdFormConfiguration);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    onFocus: () => void;
    onBlur: () => void;
    onClick: () => void;
    blur: () => void;
    focus: () => void;
    customInlineErrorValidator(): ValidatorFn;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdTextarea, [null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SdTextarea, "sd-textarea", never, { "_autoId": { "alias": "autoId"; "required": false; }; "name": { "alias": "name"; "required": false; }; "size": { "alias": "size"; "required": false; }; "appearance": { "alias": "appearance"; "required": false; }; "form": { "alias": "form"; "required": false; }; "_label": { "alias": "label"; "required": false; }; "_helperText": { "alias": "helperText"; "required": false; }; "placeholder": { "alias": "placeholder"; "required": false; }; "rows": { "alias": "rows"; "required": false; }; "model": { "alias": "model"; "required": false; }; "_hideInlineError": { "alias": "hideInlineError"; "required": false; }; "_required": { "alias": "required"; "required": false; }; "_maxlength": { "alias": "maxlength"; "required": false; }; "pattern": { "alias": "pattern"; "required": false; }; "validator": { "alias": "validator"; "required": false; }; "_inlineError": { "alias": "inlineError"; "required": false; }; "disabled": { "alias": "disabled"; "required": false; }; "_viewed": { "alias": "viewed"; "required": false; }; "_autoHeight": { "alias": "autoHeight"; "required": false; }; }, { "modelChange": "modelChange"; "sdChange": "sdChange"; }, ["sdViewDef", "sdLabelDef", "sdSuffixDef"], never, true, never>;
}
